Imports System.ComponentModel
Imports Wisej.Web

Namespace MvvmFx.Controls.WisejWeb
	''' <summary>
	''' Data binding enabled MainMenu.
	''' </summary>
	Public Class MainMenu
		Inherits Wisej.Web.MainMenu
		#Region "IBindableComponent Members"

		Private _bindingContext As BindingContext
		Private _dataBindings As ControlBindingsCollection

		''' <summary>Gets or sets the collection of currency managers for the <see cref="Wisej.Web.IBindableComponent" />. </summary>
		''' <returns>The collection of <see cref="Wisej.Web.BindingManagerBase" /> objects for this <see cref="Wisej.Web.IBindableComponent" />.</returns>
		''' <filterpriority>1</filterpriority>
		<Browsable(False)>
		Public Property BindingContext() As BindingContext
			Get
				If _bindingContext Is Nothing Then
					_bindingContext = New BindingContext()
				End If

				Return _bindingContext
			End Get
			Set(ByVal value As BindingContext)
				_bindingContext = value
			End Set
		End Property

		''' <summary>Gets the collection of data-binding objects for this <see cref="Wisej.Web.IBindableComponent" />.</summary>
		''' <returns>The <see cref="Wisej.Web.ControlBindingsCollection" /> for this <see cref="Wisej.Web.IBindableComponent" />. </returns>
		''' <filterpriority>1</filterpriority>
		<DesignerSerializationVisibility(DesignerSerializationVisibility.Content)>
		Public ReadOnly Property DataBindings() As ControlBindingsCollection
			Get
				If _dataBindings Is Nothing Then
					_dataBindings = New ControlBindingsCollection(Me)
				End If

				Return _dataBindings
			End Get
		End Property

		''' <summary>Gets or sets the collection of currency managers for the <see cref="System.Windows.Forms.IBindableComponent" />. </summary>
		''' <returns>The collection of <see cref="System.Windows.Forms.BindingManagerBase" /> objects for this <see cref="System.Windows.Forms.IBindableComponent" />.</returns>
		Private Property IBindableComponent_BindingContext() As System.Windows.Forms.BindingContext Implements System.Windows.Forms.IBindableComponent.BindingContext
			Get
				Return BindingContext
			End Get

			Set(ByVal value As System.Windows.Forms.BindingContext)
				BindingContext = CType(value, BindingContext)
			End Set
		End Property

		''' <summary>Gets the collection of data-binding objects for this <see cref="System.Windows.Forms.IBindableComponent" />.</summary>
		''' <returns>The <see cref="System.Windows.Forms.ControlBindingsCollection" /> for this <see cref="System.Windows.Forms.IBindableComponent" />.</returns>
		Private ReadOnly Property IBindableComponent_DataBindings() As System.Windows.Forms.ControlBindingsCollection Implements System.Windows.Forms.IBindableComponent.DataBindings
			Get
				Return DataBindings
			End Get
		End Property

		#End Region
	End Class
End Namespace